class Backdrop {
  float baseA, baseB;
  float dxA, dxB;
  int nslices;

  Backdrop() {
    // magic numbers for the Perlin noise generator
    baseA = 42;
    baseB = 1004;
    dxA = 0;
    dxB = 0;
    nslices = 1 + width/10;
  }

  void step() {
    // todo: make a more generic version with N parallax layers
    dxA+=0.25;
    if (dxA > 10) {
      dxA = 0;
      baseA += 0.05;
    }
    dxB+=1;
    if (dxB > 10) {
      dxB = 0;
      baseB += 0.1;
    }
  }

  void render() {
    pushMatrix();
    pushStyle();
    noStroke();
    fill(57, 13, 39);
    int x = 0;
    float p = baseA;
    translate(-dxA, 0);
    for (int i = 0; i < nslices; i++) {
      int h = int(noise(p)*100+100);
      rect(x, 400-h, 10, h);
      p += 0.05;
      x += 10;
    }
    translate(dxA-dxB, 0);
    fill(95, 14, 62);
    x = 0;
    p = baseB;
    for (int i = 0; i < nslices; i++) {
      int h = int(noise(p)*50+50);
      rect(x, 400-h, 10, h);
      p += 0.1;
      x += 10;
    }
    translate(dxB, 0);
    fill(142, 20, 79);
    rect(0, 400, width, height);
    popStyle();
    popMatrix();
  }
}

