class Boot extends GameObject {
  float px, py, v;
  float rot;
  
  Boot(int x, int y, float r) {
    super();
    px = x;
    py = y;
    v = 10;
    rot = r;
  }
  
  void step() {
    px += v*cos(rot);
    py += v*sin(rot);
    dead = (px < 0 || px > width || py < 0 || py > height);
  }
  
  void render() {
    pushMatrix();
    pushStyle();
    translate(px, py);
    rotate(rot-PI/2);
    stroke(121,62,38);
    fill(188, 120, 57);
    beginShape();
      vertex(-10, -10);
      vertex(10, -10);
      vertex(10, 20);
      vertex(30, 30);
      vertex(-10, 30);
      vertex(-10, -10);
    endShape();
    fill(77, 41, 7);
    beginShape();
      vertex(30, 30);
      vertex(30, 33);
      vertex(5, 33);
      vertex(0, 30);
      vertex(0, 33);
      vertex(-10, 33);
      vertex(-10, 30);
      vertex(30, 30);
    endShape();
    popStyle();
    popMatrix();
  }
  
  void testCollision(GameObject other) {
    other.testCollision(this);
  }
}

