abstract class GameObject {
  boolean dead;
  
  GameObject() {
    dead = false;
  }
  
  boolean isDead() {
    return dead;
  }

  abstract void step();
  
  abstract void render();
  
  abstract void testCollision(GameObject other);
  void testCollision(Boot other) {}
  void testCollision(Hunter other) {}
  void testCollision(Robot other) {}
  void testCollision(Train other) {}
  void testCollision(Wall other) {}
}

class GameObjectCollection {
  ArrayList col;
  
  GameObjectCollection() {
    col = new ArrayList();
  }
  
  void add(GameObject x) {
    col.add(x);
  }
  
  void stepAll() {
    for (int i = col.size()-1; i >= 0; i--) {
      GameObject g = (GameObject)col.get(i);
      g.step();
      if (g.isDead())
        col.remove(i);
    }
  }
  
  void renderAll() {
    for (int i = 0; i < col.size(); i++) {
      GameObject g = (GameObject)col.get(i);
      g.render();
    }
  }
  
  void collideAll(GameObjectCollection t) {
    for (int i = col.size()-1; i >= 0; i--) {
      GameObject g = (GameObject)col.get(i);
      t.collideAll(g);
      if (g.isDead())
        col.remove(i);
    }
  }

  // using "double dispatch" to handle collisions
  // albeit in a hackeneyed fashion  
  void collideAll(GameObject w) {
    for (int i = col.size()-1; i >= 0; i--) {
      GameObject g = (GameObject)col.get(i);
      g.testCollision(w);
      w.testCollision(g);
      if (g.isDead())
        col.remove(i);
      if (w.isDead())
        break;
    }
  }
}

