class Robot extends GameObject {
  int px, py, vx, vy;
  float r;
  float rlx, llx, lv;
  float rr;
  
  boolean bounce;
  
  
  Robot(int x, int y) {
    super();
    px = x;
    py = y;
    r = 0;
    rlx = -10;
    llx = 10;
    lv = 2;
    bounce = false;
    rr = 0;
  }

  void getKicked() {
    bounce = true;
    vx = -12;
    vy = -20;
  }
  
  void step() {
    rlx += lv;
    llx -= lv;
    if (rlx <= -10 || rlx >= 10)
      lv = -lv;
    if (bounce) {
      px += vx;
      py += vy;
      vy += 1;
      rr += 0.1;
    }
  }

  void render() {
  }

  void renderBody() {
    pushMatrix();
    pushStyle();
    translate(px, py);
    rotate(rr);
    stroke(201, 201, 211);
    strokeWeight(2);
    pushMatrix();
    translate(llx, 40);
    fill(105, 105, 111);
    rect(-10, -5, 20, 30);
    popMatrix();
    pushMatrix();
    translate(rlx, 40);
    fill(118, 119, 129);
    rect(-10, -5, 20, 30);
    popMatrix();
    rect(-30, -20, 60, 60);
    rect(-15, -35, 30, 15);
    noStroke();
    fill(224, 0, 0);
    rect(-12, -41, 24, 5);
    stroke(201, 201, 211);
    fill(118, 119, 129);
    rect(-15, -50, 30, 10);
    popStyle();
    popMatrix();
  }
  
  void renderArm() {
    pushMatrix();
    pushStyle();
    translate(px, py);
    rotate(r);
    stroke(201, 201, 211);
    fill(118, 119, 129);
    strokeWeight(2);
    rect(-5, -12, 33, 24);
    ellipse(0, 0, 26, 26);
    popStyle();
    popMatrix();
  }
  
  void setArmAngle(float a) {
    r = a;
  }    
  
  void testCollision(GameObject other) {
    other.testCollision(this);
  }
  
  void testCollision(Wall other) {
    if (dist(other.px, other.py, px, py) < 40) {
      gameOver();
    }
  }
  
  void testCollision(Hunter other) {
    if (dist(other.px, other.py, px, py) < 40) {
      gameOver();
    }
  }
}

