class Hunter extends GameObject {
  int px, py, v;
  float rot;  
  
  int life;
  GamePlaying parent;

  Hunter(int x, int y, float r, GamePlaying p) {
    px = x;
    py = y;
    rot = r;
    v = 7;
    life = 2;
    parent = p;
  }
  
  void step() {
    px += v*cos(rot);
    py += v*sin(rot);
    dead = (px < 0 || px > width || py < 0 || py > height);
  }
  
  void render() {
    pushMatrix();
    pushStyle();
    translate(px, py);
    strokeWeight(2);
    stroke(0, 0, 192);
    fill(0, 0, 255);
    ellipse(0, 0, 50, 50);
    rect(-25, -15, 50, 5);
    rect(-25, 10, 50, 5);
    fill(224, 224, 224);
    ellipse(0, 0, 20, 20);
    popStyle();
    popMatrix();
  }
  
  void testCollision(GameObject other) {
    other.testCollision(this);
  }
  
  void testCollision(Boot other) {
    if (dist(other.px, other.py, px, py) < 40) {
      other.dead = true;
      parent.explosions.add(new Explosion(int(other.px), int(other.py), 20, 3, 5));
      life--;
      if (life <= 0) {
        dead = true;
        parent.explosions.add(new Explosion(px, py, 30, 6, 20));
      }
      boom.trigger();
    }
  }
}

