class Train extends GameObject {
  float ang;
  int px, py;
  GamePlaying parent;
  
  Train(int x, int y, GamePlaying p) {
    super();
    px = x;
    py = y;
    ang = 0;
    parent = p;
  }
  
  void step() {
    px = px - 20;
    ang -= 0.4;
    if (ang < -2*PI)
      ang += 2*PI;
  }
  
  void render() {
    pushMatrix();
    pushStyle();
    stroke(0);
    fill(192);
    strokeWeight(3);
    translate(px, py);
    rect(-40, -50, 200, 100);
    rect(160, -80, 100, 130);
    triangle(-40, 20, -40, 90, -100, 90);
    pushMatrix();
    translate(0, 50);
    rotate(ang);
    ellipse(0, 0, 80, 80);
    rect(-5, -40, 10, 80);
    popMatrix();
    pushMatrix();
    translate(100, 50);
    rotate(ang+1);
    ellipse(0, 0, 80, 80);
    rect(-5, -40, 10, 80);
    popMatrix();  
    pushMatrix();
    translate(200, 40);
    rotate(ang+2);
    ellipse(0, 0, 100, 100);
    rect(-5, -50, 10, 100);
    popMatrix();
    popStyle();
    popMatrix();
  }
  
  void testCollision(GameObject other) {
    other.testCollision(this);
  }

  void testCollision(Robot other) {
    if (!other.isDead()) {
      if (px <= width/2 + 60) {
        other.dead = true;
        parent.explosions.add(new Explosion(width/2, 350, 60, 20, 15));
        other.getKicked();
      }
    }
  }
}

